<template>
    <div class="quill-editor">
        <div ref="editor"></div>
    </div>
</template>

<script lang='ts'>
import Vue from 'vue'
import Component from 'vue-class-component'
import { Prop, Watch } from 'vue-property-decorator'
import Quill, { QuillOptionsStatic } from 'quill'
import Delta from 'quill-delta'
import 'quill/dist/quill.core.css'
import 'quill/dist/quill.snow.css'
import _ from 'lodash'

const defaultOptions: QuillOptionsStatic = {
    theme: 'snow',
    bounds: document.body,
    modules: {
        toolbar: [
            ['bold', 'italic', 'underline', 'strike'],
            ['blockquote', 'code-block'],
            [{ header: 1 }, { header: 2 }],
            [{ list: 'ordered' }, { list: 'bullet' }],
            [{ script: 'sub' }, { script: 'super' }],
            [{ indent: '-1' }, { indent: '+1' }],
            [{ direction: 'rtl' }],
            [{ size: ['small', false, 'large', 'huge'] }],
            [{ header: [1, 2, 3, 4, 5, 6, false] }],
            [{ color: [] }, { background: [] }],
            [{ font: [] }],
            [{ align: [] }],
            ['clean'],
            ['link', 'image', 'video'],
        ],
    },
    placeholder: "What's on your mind ...",
    readOnly: false,
}

@Component
export default class QuillEditorNode extends Vue {
    // Lifecycles

    created() {
        this.defaultOptions = defaultOptions
    }

    mounted() {
        this.initialize()
    }

    beforeDestroy() {
        this.quill = null
        delete this.quill
    }

    // Props

    @Prop() content: Delta['ops'] | undefined
    @Prop({ default: false }) disabled: boolean = false

    // Data

    _options: QuillOptionsStatic = {}
    _content: Delta | null = null
    defaultOptions: QuillOptionsStatic = {}
    quill: Quill | null = null

    // Watchers

    @Watch('content')
    watchContent(newContent: Delta['ops'], oldContent: Delta['ops']) {
        if (this.quill) {
            if (!this._content) {
                this._content = new Delta(newContent)
                this.quill.setContents(this._content)
                return
            }

            if (newContent && !_.isEqual(newContent, this._content.ops)) {
                this._content = new Delta(newContent)
                this.quill.setContents(this._content)
            } else if (!newContent) {
                this.quill.setText('')
            }
        }
    }

    @Watch('disabled')
    watchDisabled(oldState: boolean, newState: boolean) {
        if (this.quill) {
            this.quill.enable(!newState)
        }
    }

    // Methods

    initialize() {
        if (this.$el) {
            // Options
            this._options = Object.assign({}, this.defaultOptions)
            // Instance
            this.quill = new Quill(this.$refs.editor as Element, this._options)

            if (!this.quill) return

            this.quill.enable(false)

            // Set editor content
            if (this.content) {
                this.quill.setContents(new Delta(this.content))
            }
            // Disabled editor
            if (!this.disabled) {
                this.quill.enable(true)
            }
            // Mark model as touched if editor lost focus
            this.quill.on('selection-change', range => {
                if (!range) {
                    this.$emit('blur', this.quill)
                } else {
                    this.$emit('focus', this.quill)
                }
            })
            // Update model if text changes
            this.quill.on('text-change', (delta, oldDelta, source) => {
                if (this.quill) this._content = this.quill.getContents()
                this.$emit('input', this._content)
            })
            // Emit ready event
            this.$emit('ready', this.quill)
        }
    }
}
</script>